// [=====================================================================]

//    Name:  ProtocolManager.h				Last Modified:  
//    Author:							First Working:  
//
// RS232.h: interface for the RS232 class.
  
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RS232_H__60754B88_0C54_42DD_A8A2_61E9841AC4AD__INCLUDED_)
#define AFX_RS232_H__60754B88_0C54_42DD_A8A2_61E9841AC4AD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


typedef void (*ONCOMM)(BYTE* pData , DWORD noOfBytes , DWORD event);

class RS232  
{
public:
	RS232();
	virtual ~RS232();
	
	bool Init( LPCTSTR Port , int Baud , int TimeGap , ONCOMM DataReceived,int iByteSize, int iParity,int iStopBits);
	void Uninit ( );
	bool Write(BYTE* buffer , int count);	

	bool m_bThreadRunning;
	HANDLE m_hPort;
	OVERLAPPED m_Overlapped;
	HANDLE m_hTxBuffEmpty;
	DWORD lpModemStat;
	DWORD	dwError;
	char	sMsg[512];
	int m_iPacketTimeGap;//this is the time interval between two packets in mili-seconds

	
	ONCOMM m_OnComm;
	HANDLE m_hEvents[3];

private:

	ONCOMM m_fpDataReceived;
	HANDLE m_hThread;
	
};

#endif // !defined(AFX_RS232_H__60754B88_0C54_42DD_A8A2_61E9841AC4AD__INCLUDED_)
