// [=====================================================================]

//    Class Name:  CKeyRetriver      Last Modified:  
//    Author:					     First Working:  
		
// [=====================================================================]
// [  Maintenance Record                                                 ]
// [---------------------------------------------------------------------]
//    Date         Version        Author                   Description
//	  09/07/2006	  1.0.6		  
// [=====================================================================]

#include "stdafx.h"
#include "KeyInjectModule.h"
#include "KeyRetriver.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeyRetriver dialog


CKeyRetriver::CKeyRetriver(CWnd* pParent /*=NULL*/)
	: CDialog(CKeyRetriver::IDD, pParent)
{

	//{{AFX_DATA_INIT(CKeyRetriver)
	m_strKey = _T("");
	m_strKerConfirm = _T("");
	m_strCaption = _T("");
	m_strLabel = _T("");
	//}}AFX_DATA_INIT
}


void CKeyRetriver::DoDataExchange(CDataExchange* pDX)
{
	
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyRetriver)
	DDX_Text(pDX, IDC_KEY, m_strKey);
	DDV_MaxChars(pDX, m_strKey, m_iKeyLen);
	DDX_Text(pDX, IDC_KEY_CONFIRM, m_strKerConfirm);
	DDV_MaxChars(pDX, m_strKerConfirm, m_iKeyLen);
	DDX_Text(pDX, IDC_KEY_NO, m_strCaption);
	DDX_Text(pDX, IDC_LBL, m_strLabel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CKeyRetriver, CDialog)
	//{{AFX_MSG_MAP(CKeyRetriver)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyRetriver message handlers

BOOL CKeyRetriver::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

	return CDialog::Create(IDD, pParentWnd);
}

void CKeyRetriver::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{

	CDialog::CalcWindowRect(lpClientRect, nAdjustType);
}

BOOL CKeyRetriver::PreCreateWindow(CREATESTRUCT& cs) 
{

	return CDialog::PreCreateWindow(cs);

}



BOOL CKeyRetriver::OnInitDialog() 
{

	CDialog::OnInitDialog();
	
	
	
	SetWindowText(m_sCaption);
	
	((CEdit*)GetDlgItem(IDC_KEY))->SetPasswordChar(m_cPasswordChar) ;
	((CEdit*)GetDlgItem(IDC_KEY_CONFIRM))->SetPasswordChar(m_cPasswordChar) ;
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CKeyRetriver::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	((CWnd*)GetDlgItem(IDC_KEY))->SetFocus();
	
}
